/-
  Homework 2

    100 total points

     66 in this file (hw2.lean)
     15 in imp/interp.lean
     19 in proof/interp.lean
-/

/-
  In this problem set, we'll do some more programming in Lean,
  study how definitions can impact proofs, and practice using
  `map` and `fold`  over trees.

  Each problem should be independent of the others, but subproblems
  may depend on each other.

  Later problems aren't necessarily harder than earlier ones, so if you get
  stuck on a problem, move on and come back to it later.

  You already know most of what you need for this homework, though
  some material this week will help with later problems.  Please
  start early so you have time to ask questions!

  For details on submission please see README.md.
-/

/-
  The following definitions are used in Problems 1 and 2.
-/

import struct_tact

namespace hw2

-- "counting" numbers
inductive counting : Type
| one : counting
| next : counting → counting

-- integers
inductive int : Type
| zero : int
| pos : counting -> int
| neg : counting -> int.

/-- Predecessor of an `int`. Used in Problem 1. -/
def pred : int → int
| int.zero := int.neg counting.one
| (int.pos n) := match n with
  | counting.one := int.zero
  | (counting.next n') := int.pos n'
end
| (int.neg n) := int.neg (counting.next n)

/- [Problem 1 (6 points)]:
   a (3 points).
      Correct the definition of [succ], below.
      succ should return the successor of its argument,
      i.e., the next larger integer.

   b (3 points).
      Complete the proofs of [pred_succ] and [succ_pred].
      _Hint_ : induction is not necessary.
 -/

def succ : int → int := fun x, x
/- TODO: fill in an implementation of sucessor -/

lemma pred_succ :
  forall x, pred (succ x) = x :=
begin
  -- TODO about 11 tactics
  admit
end

lemma succ_pred :
  forall x, succ (pred x) = x :=
begin
  -- TODO about 12 tactics
  admit
end

-- END PROBLEM 1

/-
  [PROBLEM 2 (6 points)]:

   Here are two other possible definitions of the integers:
<<
    Inductive int1 :=
    | O : int1
    | pred : int1 -> int1
    | succ : int1 -> int1.

    Inductive int2 :=
    | pos : nat -> int2
    | neg : nat -> int2.
>>

What is a potenial problem with these definitions?
Please explain briefly in a comment.

_Hint_ : To make this concrete, you may try to use
         these alternate [int] definitions in
         Problem 1 and see what happens.

  TODO: comment here
-/

-- END PROBLEM 2

-- Binary trees of `nat`s. Used in the remaining problems.
inductive nat_tree : Type
| leaf : nat_tree
| branch :
    nat -> nat_tree -> nat_tree -> nat_tree

open nat_tree

-- `size` returns the number of `nat`s in a tree.
def size : nat_tree → nat
| leaf := 0
| (branch n ntl ntr) := (size ntl) + (size ntr) + 1

/--
  [PROBLEM 3 (6 points)]:

  Define [sum] to add up all the [nat]s in a [nat_tree].
-/

def sum : nat_tree → nat :=
/- TODO -/ fun _, 0

-- /- END PROBLEM 3 -/

/--
  [PROBLEM 4 (6 points)]:

  Define [prod] to multiply all the [nat]s in a [nat_tree].
  _Hint_ : prod should call mult.
-/

def prod : nat_tree → nat
  /- TODO -/ := fun _, 0

-- /- END PROBLEM 4 -/

-- `fold` over `nat_tree`s
def fold {T: Type} : T → (T → nat → T) → nat_tree → T
| base f leaf := base
| base f (branch n l r) := f (fold (fold base f l) f r) n

/--
  [PROBLEM 5 (6 points)]:

  Define [sum'] to add up all the [nat]s in a [nat_tree].

  For full credit, do not use recursion.
  (Keep the Definition, don't change to Fixpoint).
-/
def sum' (nt : nat_tree) : nat :=
/- TODO -/ 0

-- /- END PROBLEM 5 -/

/-
  [PROBLEM 6 (6 points)]:

  Define [prod'] to multiply up all the [nat]s in a [nat_tree].

  For full credit, do not use recursion.
  (Keep the Definition, don't change to Fixpoint).
-/

def prod' (nt : nat_tree) : nat :=
  /- TODO -/ 0

-- /- END PROBLEM 6 -/

/-
  [PROBLEM 7 (6 points)]:

  Define [increment_all] to add one to all the [nat]s in a [nat_tree].
-/

def increment_all : nat_tree → nat_tree :=
  /- TODO -/ fun n, n

-- /- END PROBLEM 7 -/

/-
  [PROBLEM 8 (6 points)]:

  Define [double] to multiply all the [nat]s in a [nat_tree] by 2.
-/

def double : nat_tree → nat_tree
| nt := nt /- TODO -/

-- END PROBLEM 8

/-
  [PROBLEM 9 (6 points)]:

   a (3 points).
     Define [map] to apply a function of type [nat -> nat]
     to every [nat] in a [nat_tree].

     The resulting tree should have exactly the same
     structure as the initial tree.

   b (3 points).
     Complete the proof of [size_map], which proves that
     [map] preserves the [size] of a [nat_tree].
-/

def map (f: nat -> nat) : nat_tree → nat_tree
| nt := /- TODO -/ nt

lemma size_map : forall f t, size (map f t) = size t :=
begin
  /- TODO about 3 tactics -/
  admit
end

-- /- END PROBLEM 9 -/

/--
 [PROBLEM 10 (6 points)]:
   a (3 points).
     Define [mirror] to flip all the branches in the tree:
               5              5
              / \            / \
             3   4     =>   4   3
            / \                / \
           1   6              6   1
      (leaves are not displayed above)

   b (3 points).
     Complete the proof of [size_mirror], which proves
     that mirror preserves the [size] of a [nat_tree].

     _Hint_ : you will likely need to use a lemma about
     [plus] from the [Arith] library (imported at the
     top of this file).  You can search for lemmas using
     the [SearchAbout] command.
-/

def mirror : nat_tree → nat_tree
  /- fill in your definition of mirror here -/
:= fun n, n

theorem size_mirror : forall t, size (mirror t) = size t :=
begin
  /- about 3 tactics -/
  admit
end

/- TODO END PROBLEM 10 -/

/--
  [PROBLEM 11 (6 points)]:

  Consider this alternate definition of fold:
-/
def fold' {T: Type} : T → (T -> nat -> T) → nat_tree → T
| base f nat_tree.leaf := base
| base f (nat_tree.branch n l r) := fold' (f (fold' base f l) n) f r

/-
In a short English paragraph, describe how fold and fold' differ.
-/

/- TODO WRITE HERE -/

-- END PROBLEM 11

/- OPTIONAL Bonus A:

  What should be true about a particular f for the following to hold:

    [forall b nt, fold b f nt = fold' b f nt]

    TODO write here
-/

/- OPTIONAL Bonus B:

  Formalize this property in Lean, and prove that
    [forall f b nt, <property> f -> fold b f nt = fold' b f nt].

-/

end hw2
