import struct_tact
import ..imp
import .eval
import .semantics

namespace imp

lemma interp_op1_eval_op1 :
  forall op v v',
    interp.op1 op v = some v' →
    eval.unary_op op v v' :=
begin
  intros; cases op ;
    cases v with v1;
    simp [interp.op1] at a;
    cases a;
  constructor
end

lemma eval_op1_interp_op1 :
  forall op v v',
    eval.unary_op op v v' ->
    interp.op1 op v = some v' :=
begin
  intros; cases a; simp [interp.op1],
end

lemma interp_op2_eval_op2 :
  forall op v1 v2 v',
    interp.op2 op v1 v2 = some v' →
    eval.binary_op op v1 v2 v' :=
begin
  /-*
    6 points

    TODO Complete this begin
    ( ~ 10 tactics )
  -/
  admit
end

lemma eval_op2_interp_op2 :
  forall op v1 v2 v',
    eval.binary_op op v1 v2 v' ->
    interp.op2 op v1 v2 = some v' :=
begin
  /-*
    NOTE : this proof should go through
           once you have completed the problems
           in imp/interp.lean

  intros; cases a; simp [interp.op2],
    by_cases (i2 = 0); simp * at *,
    by_cases (i2 = 0); simp * at *,
end
  -/
  admit
end

lemma interp_expr_eval_expr :
  forall s h e v,
    interp.exp s h e = some v →
    eval.expr s h e v :=
begin
    induction_on e; intros; simp [interp.exp] at *,
    { cases a_1, constructor },
    { constructor, assumption },
    { simp_option a_2,
      constructor,
      apply ih_1; assumption,
      apply interp_op1_eval_op1; assumption },
    { simp_option a_3,
      simp_option right,
      constructor,
      apply ih_1; assumption,
      apply ih_2; assumption,
      apply interp_op2_eval_op2; assumption,
    },
    { simp_option a_1,
      break_match,
      cases right,
      subst a_2,
      apply eval.expr.length_s,
      apply ih_1; try { assumption },
      trivial,
      break_match,
      cases right,
      constructor; try { assumption },
      apply ih_1, simp * at *,
    },
    { simp_option a_2,
      simp_option right,
      break_match,
      cases a_4,
      break_if,
      simp_option right_1,
      cases right,
      apply eval.expr.index_s; try { assumption },
      apply ih_1; try { assumption }; trivial,
      apply ih_2; try { assumption }; trivial,
      simp_option right_1,
      cases a_4,
      break_match,
      break_if,
      constructor,
      apply ih_1; try { assumption }; trivial,
      apply ih_2; try { assumption }; trivial,
      assumption,
      simp * at *,
      simp * at *,
    }
end

lemma eval_expr_interp_expr :
  forall s h e v,
    eval.expr s h e v →
    interp.exp s h e = some v :=
begin
    intros, induction_on a,
    case eval.expr.unary_op {
        simp [interp.exp],
        apply option_bind_some_back,
        assumption,
        apply eval_op1_interp_op1 ; assumption
    },
    case eval.expr.binary_op {
        simp [interp.exp],
        apply option_bind_some_back ; try { assumption },
        apply option_bind_some_back ; try { assumption },
        apply eval_op2_interp_op2 ; assumption
    },
    case eval.expr.val {
        simp [interp.exp],
    },
    case eval.expr.var {
        simp [interp.exp],
        assumption
    },
    case eval.expr.length_a {
        simp [interp.exp],
        apply option_bind_some_back ; try { assumption },
        apply option_bind_some_back ; try { assumption },
        trivial,
    },
    case eval.expr.length_s {
        simp [interp.exp],
        apply option_bind_some_back ; try { assumption },
        break_match,
        cases a_3,
        simp * at *,
    },
    case eval.expr.index_a {
        simp [interp.exp],
        apply option_bind_some_back ; try { assumption },
        apply option_bind_some_back ; try { assumption },
        apply option_bind_some_back ; try { assumption },
        break_match; try { cases a_7 },
        simp *, simp * at a_5, assumption,
    },
    case eval.expr.index_s {
        simp [interp.exp],
        apply option_bind_some_back ; try { assumption },
        apply option_bind_some_back ; try { assumption },
        break_match,
        cases a_6, dsimp, -- fix me
        break_if,
        apply option_bind_some_back; trivial,
    },
end

lemma interp_seq_eval_eval_seq_eval :
  forall s h es vs,
    interp.seq_exp s h es = some vs →
    eval.seq_expr s h es vs :=
begin
  induction_on es ; intros,
  { simp [interp.seq_exp] at a,
    cases a, constructor,
  },
  { simp [interp.seq_exp] at a_2,
    simp_option a_2,
    simp_option right,
    cases right_1,
    constructor,
    apply interp_expr_eval_expr; assumption,
    apply ih_1; assumption,
  }
end

lemma interp_stmt_eval_stmt :
  forall ioi fuel env s h p s' h',
    interp.stmt ioi fuel env s h p = some (s', h') →
    eval.stmt env s h p s' h' :=
begin
  /-*
    13 points

    TODO:
    Complete the proof that the interpreter you just completed
    matches the semantics defined in `src/proof/eval.lean`.

    Many of the cases are straight forward, but a few are more
    involved.

    Think carefully about how the proof should proceed informally
    before beginning, which cases do you need to examine?

    ( around 100 tactics )
  -/
  admit
end

lemma interp_program_eval_program :
  forall ioi n funcs main ret h' v',
    interp.program ioi n (prog.mk funcs main ret) = some (h', v') ->
    eval.program (prog.mk funcs main ret) h' v' :=
begin
    intros,
    simp [interp.program] at *,
    break_match,
    break_match,
    cases a,
    constructor,
    apply interp_stmt_eval_stmt ; try { assumption },
    apply interp_expr_eval_expr ; try { assumption },
end


end imp
